-- Ping Direction

local function cMessage(msg)
        if (DEFAULT_CHAT_FRAME) then
                DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

local RealmName = GetCVar("realmname");
local PlayerName = UnitName("player");

local UpdateTime = 0.1;
local lastupdate = 0;
local minimapPlayerModel;	-- For calculating player heading
local minimapRingModel;		-- For calculating minimap rotation

local LastXY = "ping";
local Coord = {x=50,y=50};
local GPS = {x=50,y=50};

-- Hook WorldFrame mouseclicks...
local LeftClicking = false;	-- Kludge to detect left-clicking in game world
local Orig_MouseDown = WorldFrame:GetScript("OnMouseDown");
local Orig_MouseUp = WorldFrame:GetScript("OnMouseUp");
WorldFrame:SetScript("OnMouseDown", function() PingDir_MouseDown(arg1); end);
WorldFrame:SetScript("OnMouseUp", function() PingDir_MouseUp(arg1); end);

--local PingFudgeX=0.0;
--local PingFudgeY=0.0;

-------------------------------------------------------------------------------

function PingDir_MouseDown(arg1)
	if (arg1 == "LeftButton") then
		--DEFAULT_CHAT_FRAME:AddMessage("LeftMouseDown");
		LeftClicking = true;
	end

	if Orig_MouseDown then
		Orig_MouseDown();
	end
end

function PingDir_MouseUp(arg1)
	if (arg1 == "LeftButton") then
		--DEFAULT_CHAT_FRAME:AddMessage("LeftMouseUp");
		LeftClicking = false;
	end

	if Orig_MouseDown then
		Orig_MouseDown();
	end
end

-------------------------------------------------------------------------------

function PingDir_OnLoad()
	PingDirArrowFrame:SetAlpha(0.0);
	PingDirGPSFrame:SetAlpha(0.0);
	-- Yeah, I'll get around to non-hardcoding these later :P
	PingDirArrowFrameTexture:SetVertexColor(PINGDIR_ARROW_COLOUR.r, PINGDIR_ARROW_COLOUR.g, PINGDIR_ARROW_COLOUR.b);
	PingDirGPSFrameTexture:SetVertexColor(PINGDIR_GPS_COLOUR.r, PINGDIR_GPS_COLOUR.g, PINGDIR_GPS_COLOUR.b);

	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("MINIMAP_PING");

	-- Setup SLASH
	SlashCmdList["PINGDIR"] =
		function(args)
			PingDir_SlashCmd(args)
		end

	SlashCmdList["GPS"] =
		function(args)
			PingDirGPS_SlashCmd(args)
		end

	-- Much thanks to Kirov's SimpleCompass for the method!
	-- Create a table of all the Minimap's children objects.
	local children = {Minimap:GetChildren()};
	
	for i=getn(children), 1, -1 do
		local name = children[i]:GetName();
		if children[i]:IsObjectType("Model") and name and (name == "MiniMapCompassRing") then
			minimapRingModel = children[i];
		end
		-- Iterate over them all, starting from the end of the list to see if the object reference is a model.
		-- If it is, and it has no name (in case some addon attached a model to it), it's probably the right one.
		if children[i]:IsObjectType("Model") and not name then
			-- Found, setting as the addon's local to keep the reference.
			minimapPlayerModel = children[i];
			return;
		end
	end

end

function PingDir_OnEvent(event)
	--if event then
	--	DEFAULT_CHAT_FRAME:AddMessage("event="..event);
	--end
	if (event == "VARIABLES_LOADED") then
		if not PingDirection then PingDirection = {}; end
		if not PingDirection[RealmName] then PingDirection[RealmName] = {}; end
		if not PingDirection[RealmName][PlayerName] then
			PingDirection[RealmName][PlayerName] = {};
			PingDirection[RealmName][PlayerName].Enabled = true;
		end
		
		-- Some default numbers
		if not PingDirection[RealmName][PlayerName].Radius then
			PingDirection[RealmName][PlayerName].Radius = PINGDIR_RADIUSDEFAULT;
		end
		if not PingDirection[RealmName][PlayerName].Squish then
			PingDirection[RealmName][PlayerName].Squish = PINGDIR_RATIODEFAULT;
		end
		if not PingDirection[RealmName][PlayerName].Scale then
			PingDirection[RealmName][PlayerName].Scale = PINGDIR_SCALEDEFAULT;
		end
		if not PingDirection[RealmName][PlayerName].FPS then
			PingDirection[RealmName][PlayerName].FPS = PINGDIR_FPSDEFAULT;
		end
		if not PingDirection[RealmName][PlayerName].Fade then
			PingDirection[RealmName][PlayerName].Fade = PINGDIR_FADEDEFAULT;
		end
		if not PingDirection[RealmName][PlayerName].Text then
			PingDirection[RealmName][PlayerName].Text = true;
		end
		if not PingDirection[RealmName][PlayerName].Alpha then
			PingDirection[RealmName][PlayerName].Alpha = PINGDIR_ALPHADEFAULT;
		end


		UpdateTime = 1 / PingDirection[RealmName][PlayerName].FPS;
		PingDirArrowFrame:SetHeight(PINGDIR_YDIM * PingDirection[RealmName][PlayerName].Squish);
		PingDirGPSFrame:SetHeight(PINGDIR_YDIM * PingDirection[RealmName][PlayerName].Squish);
		PingDirArrowFrame:SetScale(PingDirection[RealmName][PlayerName].Scale);
		PingDirGPSFrame:SetScale(PingDirection[RealmName][PlayerName].Scale);

		if PingDirection[RealmName][PlayerName].Text then
			PingDirArrowFrameText:Show();
			PingDirGPSFrameText:Show();
		else
			PingDirArrowFrameText:Hide();
			PingDirGPSFrameText:Hide();
		end

		if DEFAULT_CHAT_FRAME then
			DEFAULT_CHAT_FRAME:AddMessage(PINGDIR_NAME.." "..PINGDIR_VERSION.." "..PINGDIR_LOADED);
		end
	elseif (event == "MINIMAP_PING") then
		-- Flash the arrow
		if not PingDirection[RealmName][PlayerName].Enabled then return; end
		UIFrameFadeOut(getglobal("PingDirArrowFrame"), PingDirection[RealmName][PlayerName].Fade, 1.0, 0.0);
		PingDirArrowFrameText:SetText(UnitName(arg1));

		LastXY = "ping";

		--lastx, lasty = Minimap:GetPingPosition();
		-- It's not perfectly centered! Argh!
		--lastx = lastx + 0.05;
		--lasty = lasty + 0.05;

		--lastx = arg2;
		--lasty = arg3;
		--DEFAULT_CHAT_FRAME:AddMessage("p="..arg1..", x="..lastx..", y="..lasty);
	end
end

function PingDir_OnUpdate(elapsed)
	local pitch, yaw, squish

	if not PingDirection[RealmName][PlayerName].Enabled then return; end

	lastupdate = lastupdate - elapsed;
	if (lastupdate > 0) then return; end
	lastupdate = UpdateTime;

	if not minimapPlayerModel then return; end
	local Facing = minimapPlayerModel:GetFacing() - (1.5 * math.pi); -- radians, 0 = east
	-- Compensate for camera location
	if PingDirection[RealmName][PlayerName].Camera then
		-- We eat up the 5th saved camera spot when we do this
		SaveView(5);
		pitch = tonumber(GetCVar("cameraPitchD"));
		-- pitch is 0 when level with ground +pi/2 straight above, -pi/2 straight below

		yaw = tonumber(GetCVar("cameraYawD"));
		yaw = yaw * (2 * math.pi) / 360;
		-- yaw is 0 whenstraight behind, pi/2 straight right, pi forwards, and 3*pi/2 left

		-- Here's some weirdness for you
		-- When turning with left or right mouse button, camera yaw is relative to game world
		-- When not, camera yaw variable is relative to your player.

		-- HOWEVER, IsMouselooking catches player turning with the RIGHT mouse button, and not camera movement with left.
		-- So, we will be hooking WorldFrame:OnMouseDown...

		if LeftClicking or IsMouselooking() then
			--yaw = yaw - Facing + (math.pi/2);
			--Facing = Facing + yaw;
			Facing = yaw + (math.pi/2); -- Camera angle is 90 degree offset from our reference point (straight left).

			-- 2.1 change: Rotating minimap places the ping coordinates relative to player instead of north:
			-- So, we need the camera angle relative to player instead of north.

			-- When NOT mouselooking, since minimap ping coordinates are relative to your player pointing straight up
			-- and camera yaw is relative to your player already, this works fine.

			-- However, WHEN mouselooking, camera yaw is relative to north, and I can't use playermodelfacing to get
			-- the player facing to compensate and get a relative-to-player camera angle

			-- So... we use the ring model
			if (GetCVar("rotateMinimap") == "1") and minimapRingModel then
				local MapRotation = minimapRingModel:GetFacing();
				-- This angle seems to be 0 when pointed straight north, -pi/2 west, -pi south, -3*pi/2 east
				Facing = Facing + MapRotation;
			end
		else
			Facing = Facing + yaw;
		end

		-- Squish!
		squish = abs(pitch) / 90;
		PingDirArrowFrame:SetHeight(PINGDIR_YDIM * squish);
		PingDirGPSFrame:SetHeight(PINGDIR_YDIM * squish);
	else
		squish = PingDirection[RealmName][PlayerName].Squish;
	end
	-- Facing is the camera (or player, if compensation not enabled) heading, relative to due EAST
	--DEFAULT_CHAT_FRAME:AddMessage("Facing = "..Facing);


	-- Get Ping direction
	local lastx, lasty = PingDir_GetXY(LastXY);
	local PingAngle = math.atan2(lasty, lastx);

	-- Calculate delta
	local Bearing = PingAngle - Facing;
	-- However, if we are below the player, we will have to flip it vertically
	if PingDirection[RealmName][PlayerName].Camera and (pitch < 0) then
		Bearing = -Bearing + math.pi;
	end

	-- Since we're calculating the corner coordinates, easier to rotate a 45 degree offset instead.
	local r = (5*math.pi/4) - Bearing;

	-- Texture rotation. 0.7071067811 being sqrt(0.5*0.5 + 0.5*0.5), hypotenuse of a 0.5x0.5 right triangle;
	local sinr = math.sin(r) * 0.7071067811;
	local cosr = math.cos(r) * 0.7071067811;

	-- Texture:SetTexCoord(minX, maxX, minY, maxY or ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
	PingDirArrowFrameTexture:SetTexCoord(0.5-sinr, 0.5+cosr, 0.5-cosr, 0.5-sinr, 0.5+cosr, 0.5+sinr, 0.5+sinr, 0.5-cosr);

	-- Reposition and squish arrow
	PingDirArrowFrame:ClearAllPoints();
	PingDirArrowFrame:SetPoint("CENTER", "UIParent", "CENTER",
		-math.sin(Bearing) * PingDirection[RealmName][PlayerName].Radius,
		math.cos(Bearing) * PingDirection[RealmName][PlayerName].Radius * squish);

	--if MWDEBUG then
	--	DEFAULT_CHAT_FRAME:AddMessage("Pingx/y = ("..lastx..","..lasty..") PingAngle="..PingAngle..", Facing="..Facing..", Bearing="..Bearing);
	--	DEFAULT_CHAT_FRAME:AddMessage("Bearing="..Bearing.." (sinr, cosr)=("..sinr..", "..cosr..")");
	--end
	if (GPS.x ~= -1) and (GPS.y ~= -1) then
		-- Yay, redo the math
		lastx, lasty = PingDir_GetXY("gps");
		--DEFAULT_CHAT_FRAME:AddMessage("GPS = ("..lastx..","..lasty..")");

		-- Check if we're  close enough
		if (math.abs(lastx) < 0.05) and (math.abs(lasty) < 0.05) then
			PingDirGPSFrameText:SetText(string.format(">>> %2.1f, %2.1f <<<", GPS.x, GPS.y));
			PingDirGPSFrameTexture:SetVertexColor(PINGDIR_GPS_FLASH.r, PINGDIR_GPS_FLASH.g, PINGDIR_GPS_FLASH.b);
			UIFrameFadeOut(getglobal("PingDirGPSFrame"), 1.0, 1.0, 0.0);
			PlaySound("MapPing");
			GPS.x = -1;
			GPS.y = -1;
			return;
		end

		PingAngle = math.atan2(lasty, lastx);
		Bearing = PingAngle - Facing;
		-- Camera below horizontal compensation
		if PingDirection[RealmName][PlayerName].Camera and (pitch < 0) then
			Bearing = -Bearing + math.pi;
		end
		r = (5*math.pi/4) - Bearing;
		sinr = math.sin(r) * 0.7071067811;
		cosr = math.cos(r) * 0.7071067811;

		PingDirGPSFrameTexture:SetTexCoord(0.5-sinr, 0.5+cosr, 0.5-cosr, 0.5-sinr, 0.5+cosr, 0.5+sinr, 0.5+sinr, 0.5-cosr);

		-- Reposition and squish arrow
		PingDirGPSFrame:ClearAllPoints();
		PingDirGPSFrame:SetPoint("CENTER", "UIParent", "CENTER",
			-math.sin(Bearing) * PingDirection[RealmName][PlayerName].Radius,
			math.cos(Bearing) * PingDirection[RealmName][PlayerName].Radius * squish);
	end
end

function PingDir_GetXY(coordtype)
	local x = 0;
	local y = 1.0;

	if (coordtype == "ping") then
		x, y = Minimap:GetPingPosition();
		-- Position is slightly off... have to adjust for it.
		-- Looks like in 2.1, we don't have to fudge it anymore. Woohoo!
		--x = x + PingFudgeX;
		--y = y + PingFudgeY;
	elseif (coordtype == "coord") then
		-- We are not doing any compensation for zone changing functionality at this time
		local px, py = GetPlayerMapPosition("player");
		x = Coord.x - (px * 100);
		y = (100 - Coord.y) - ((1 - py) * 100);
	elseif (coordtype == "gps") then
		-- We are not doing any compensation for zone changing functionality at this time
		local px, py = GetPlayerMapPosition("player");
		x = GPS.x - (px * 100);
		y = (100 - GPS.y) - ((1 - py) * 100);
	end

	return x,y;
end

function PingDirGPS_SlashCmd(args)
	if (args) then
		local opts=string.lower(args);
		if (opts == "") then
			PingDir_ShowHelp();
		elseif (opts == PINGDIR_SLASH_OFF) then
			PingDirGPSFrame:SetAlpha(0);
			GPS.x = -1;
			GPS.y = -1;
		-- Trap the ##,## and ## ## situations
		elseif (string.find(opts, PINGDIR_SLASH_ALPHA.." ") == 1) then
			local i = tonumber(string.sub(opts, string.len(PINGDIR_SLASH_ALPHA) + 2, string.len(opts)));
			if (i >= PINGDIR_ALPHAMIN) and (i <= PINGDIR_ALPHAMAX) then
				PingDirection[RealmName][PlayerName].Alpha = i;
				PingDirGPSFrameTexture:SetAlpha(i);
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_ALPHA..i);
			else
				cMessage(PINGDIR_NAME..": "..PINGDIR_ERROR_ALPHA);
			end
		elseif (string.find(opts, "[%d.]+[, ]*[%d.]+")) then
			local x,y;
			_,_,x,y = string.find(opts,"([%d.]+)[, ]*([%d.]+)");
			x = tonumber(x); y = tonumber(y);
			if x and y and (x >= 0) and (x <= 100) and (y >= 0) and (y <= 100) then
				LastXY = "coord";
				GPS.x = x;
				GPS.y = y;
				PingDirGPSFrameTexture:SetVertexColor(PINGDIR_GPS_COLOUR.r, PINGDIR_GPS_COLOUR.g, PINGDIR_GPS_COLOUR.b);
				PingDirGPSFrame:SetAlpha(1.0);
				PingDirGPSFrameTexture:SetAlpha(PingDirection[RealmName][PlayerName].Alpha);
				PingDirGPSFrameText:SetText(string.format("%2.1f, %2.1f", x, y));
			end
		end
	end
end

function PingDir_SlashCmd(args)
	local i;
	if (args) then
		local opts=string.lower(args);
		if (opts == "") then
			PingDir_ShowHelp();
		elseif (opts == PINGDIR_SLASH_STATUS) then
			PingDir_Status();
		elseif (opts == PINGDIR_SLASH_ON) then
			PingDirection[RealmName][PlayerName].Enabled = true;
			cMessage(PINGDIR_NAME..": "..PINGDIR_ENABLED);
		elseif (opts == PINGDIR_SLASH_OFF) then
			PingDirection[RealmName][PlayerName].Enabled = false;
			cMessage(PINGDIR_NAME..": "..PINGDIR_DISABLED);
		elseif (opts == PINGDIR_SLASH_TEXT) then
			if PingDirection[RealmName][PlayerName].Text then
				PingDirection[RealmName][PlayerName].Text = false;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_TEXT..PINGDIR_DISABLED);
				PingDirArrowFrameText:Hide();
				PingDirGPSFrameText:Hide();
			else
				PingDirection[RealmName][PlayerName].Text = true;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_TEXT..PINGDIR_ENABLED);
				PingDirArrowFrameText:Show();
				PingDirGPSFrameText:Show();
			end
		elseif (opts == PINGDIR_SLASH_CAMERA) then
			if PingDirection[RealmName][PlayerName].Camera then
				PingDirection[RealmName][PlayerName].Camera = false;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_CAMERA..PINGDIR_DISABLED);
			else
				PingDirection[RealmName][PlayerName].Camera = true;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_CAMERA..PINGDIR_ENABLED);
			end
		elseif (string.find(opts, PINGDIR_SLASH_FPS.." ") == 1) then
			i = tonumber(string.sub(opts, string.len(PINGDIR_SLASH_FPS) + 2, string.len(opts)));
			if (i >= PINGDIR_FPSMIN) and (i <= PINGDIR_FPSMAX) then
				PingDirection[RealmName][PlayerName].FPS = i;
				UpdateTime = 1 / PingDirection[RealmName][PlayerName].FPS;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_FPS..i);
			else
				cMessage(PINGDIR_NAME..": "..PINGDIR_ERROR_FPS);
			end
		elseif (string.find(opts, PINGDIR_SLASH_FADE.." ") == 1) then
			i = tonumber(string.sub(opts, string.len(PINGDIR_SLASH_FADE) + 2, string.len(opts)));
			if (i >= PINGDIR_FADEMIN) and (i <= PINGDIR_FADEMAX) then
				PingDirection[RealmName][PlayerName].Fade = i;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_FADE..i);
			else
				cMessage(PINGDIR_NAME..": "..PINGDIR_ERROR_FADE);
			end
		elseif (string.find(opts, PINGDIR_SLASH_RATIO.." ") == 1) then
			i = tonumber(string.sub(opts, string.len(PINGDIR_SLASH_RATIO) + 2, string.len(opts)));
			if (i >= PINGDIR_RATIOMIN) and (i <= PINGDIR_RATIOMAX) then
				PingDirection[RealmName][PlayerName].Squish = i;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_RATIO..i);
				PingDirArrowFrame:SetHeight(PINGDIR_YDIM * PingDirection[RealmName][PlayerName].Squish);
				PingDirGPSFrame:SetHeight(PINGDIR_YDIM * PingDirection[RealmName][PlayerName].Squish);
			else
				cMessage(PINGDIR_NAME..": "..PINGDIR_ERROR_RATIO);
			end
		elseif (string.find(opts, PINGDIR_SLASH_SCALE.." ") == 1) then
			i = tonumber(string.sub(opts, string.len(PINGDIR_SLASH_SCALE) + 2, string.len(opts)));
			if (i >= PINGDIR_SCALEMIN) and (i <= PINGDIR_SCALEMAX) then
				PingDirection[RealmName][PlayerName].Scale = i;
				cMessage(PINGDIR_NAME..": "..PINGDIR_MSG_SCALE..i);
				PingDirArrowFrame:SetScale(i);
				PingDirGPSFrame:SetScale(i);
			else
				cMessage(PINGDIR_NAME..": "..PINGDIR_ERROR_SCALE);
			end
		-- Trap the ##,## and ## ## situations
		elseif (string.find(opts, "[%d.]+[, ]*[%d.]+")) then
			local x,y;
			_,_,x,y = string.find(opts,"([%d.]+)[, ]*([%d.]+)");
			if x and y then
				x = tonumber(x); y = tonumber(y);
				if x and y and (x >= 0) and (x <= 100) and (y >= 0) and (y <= 100) then
					LastXY = "coord";
					Coord.x = x;
					Coord.y = y;
					PingDirArrowFrameText:SetText(string.format("%2.1f, %2.1f", x, y));
					UIFrameFadeOut(getglobal("PingDirArrowFrame"), PingDirection[RealmName][PlayerName].Fade, 1.0, 0.0);
				end
			end
		end
	end
end

function PingDir_ShowHelp()
        local i;
	for i=1, table.getn(PINGDIR_HELPTEXT) do
		cMessage(PINGDIR_HELPTEXT[i]);
	end
end

function PingDir_Status()
	if PingDirection[RealmName][PlayerName].Enabled then
		cMessage(PINGDIR_NAME.." "..PINGDIR_VERSION..": ".. PINGDIR_ENABLED);
	else
		cMessage(PINGDIR_NAME.." "..PINGDIR_VERSION..": ".. PINGDIR_DISABLED);
	end
	cMessage("     "..PINGDIR_MSG_FPS..PingDirection[RealmName][PlayerName].FPS);
	cMessage("     "..PINGDIR_MSG_FADE..PingDirection[RealmName][PlayerName].Fade);
	cMessage("     "..PINGDIR_MSG_RATIO..PingDirection[RealmName][PlayerName].Squish);
	cMessage("     "..PINGDIR_MSG_SCALE..PingDirection[RealmName][PlayerName].Scale);
	if PingDirection[RealmName][PlayerName].Text then
		cMessage("     "..PINGDIR_MSG_TEXT..PINGDIR_DISABLED);
	else
		cMessage("     "..PINGDIR_MSG_TEXT..PINGDIR_ENABLED);
	end
	if PingDirection[RealmName][PlayerName].Camera then
		cMessage("     "..PINGDIR_MSG_CAMERA..PINGDIR_DISABLED);
	else
		cMessage("     "..PINGDIR_MSG_CAMERA..PINGDIR_ENABLED);
	end
	cMessage("     "..PINGDIR_MSG_ALPHA..PingDirection[RealmName][PlayerName].Alpha);
end

